#include <iostream>
using namespace std;

// passing by value
// will not modify the value
void Foo(int x) {
    cout << "FOO x = " << x << "\n";
    x += 1;
    cout << "BAR x = " << x << "\n";
}

// passing by reference
// will modify the value if a reference is used
void Foo(int x, int& y) {
    cout << "FOO x = " << x << "\n";
    cout << "FOO y = " << y << "\n";
    x += 1;
    y += 2;
    cout << "BAR x = " << x << "\n";
    cout << "BAR j = " << y << "\n";
}

// passing by pointer
// will modify the value if a pointer is used
void Foo(int x, int& y, int* z) {
    cout << "FOO x = " << x << "\n";
    cout << "FOO y = " << y << "\n";
    cout << "FOO z = " << *z << "\n";
    x += 1;
    y += 2;
    *z += 3;  // use the * operator when using pointers
    cout << "BAR x = " << x << "\n";
    cout << "BAR j = " << y << "\n";
    cout << "BAR z = " << *z << "\n";
}

int main() {
    int i = 10;
    int j = 20;
    int k = 30;
    cout << "ORIG i = " << i << "\n";
    cout << "ORIG j = " << j << "\n";
    cout << "ORIG k = " << k << "\n";
    Foo(i, j, &k);  // when passing by pointer, used &
    cout << "AFTER i = " << i << "\n";
    cout << "AFTER j = " << j << "\n";
    cout << "AFTER k = " << k << "\n";
}